const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;
const STATE_IS_DOCUMENT = Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT;

var MHO_SHARE_SIDEBAR_LISTENER = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
			aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
			aIID.equals(Components.interfaces.nsISupports)) {
			return this;
		}

		throw Components.results.NS_NOINTERFACE;
	},

	onLocationChange: function() {},

	onStateChange: function(aProgress, aRequest, aStateFlags, aStatus) {
		if (STATE_IS_DOCUMENT & aStateFlags) {
			if (STATE_START & aStateFlags) {
				// Show progress meter
				document.getElementById("mho-share-browser-deck").selectedIndex = 0;
			}
			else if (STATE_STOP & aStateFlags) {
				// Show browser
				document.getElementById("mho-share-browser-deck").selectedIndex = 1;
			}
		}
	},
	
	onProgressChange: function() {},
	onStatusChange: function() {},
	onSecurityChange: function() {},
	onLinkIconAvailable: function() {}
};

addEventListener("load", function () { document.getElementById("mahalo-share-browser").addProgressListener(MHO_SHARE_SIDEBAR_LISTENER, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT); }, false);
addEventListener("unload", function () { document.getElementById("mahalo-share-browser").removeProgressListener(MHO_SHARE_SIDEBAR_LISTENER); }, false);